diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/test.py ns-3.41/test.py
--- ns-3.40/test.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/test.py	2024-02-09 14:44:08.629795300 -0800
@@ -18,6 +18,7 @@
 import argparse
 import fnmatch
 import os
+import queue
 import shutil
 import signal
 import subprocess
@@ -26,29 +27,44 @@
 import time
 import xml.etree.ElementTree as ET
 
-
 from utils import get_list_from_file
 
 # Global variable
 args = None
 
 # imported from waflib Logs
-colors_lst={'USE':True,'BOLD':'\x1b[01;1m','RED':'\x1b[01;31m','GREEN':'\x1b[32m','YELLOW':'\x1b[33m','PINK':'\x1b[35m','BLUE':'\x1b[01;34m','CYAN':'\x1b[36m','GREY':'\x1b[37m','NORMAL':'\x1b[0m','cursor_on':'\x1b[?25h','cursor_off':'\x1b[?25l',}
+colors_lst = {
+    "USE": True,
+    "BOLD": "\x1b[01;1m",
+    "RED": "\x1b[01;31m",
+    "GREEN": "\x1b[32m",
+    "YELLOW": "\x1b[33m",
+    "PINK": "\x1b[35m",
+    "BLUE": "\x1b[01;34m",
+    "CYAN": "\x1b[36m",
+    "GREY": "\x1b[37m",
+    "NORMAL": "\x1b[0m",
+    "cursor_on": "\x1b[?25h",
+    "cursor_off": "\x1b[?25l",
+}
+
+
 def get_color(cl):
-    if colors_lst['USE']:
-        return colors_lst.get(cl, '')
-    return ''
+    if colors_lst["USE"]:
+        return colors_lst.get(cl, "")
+    return ""
+
+
 class color_dict(object):
     def __getattr__(self, a):
         return get_color(a)
+
     def __call__(self, a):
         return get_color(a)
+
+
 colors = color_dict()
 
-try:
-    import queue
-except ImportError:
-    import Queue as queue
 #
 # XXX This should really be part of a ns3 command to list the configuration
 # items relative to optional ns-3 pieces.
@@ -63,7 +79,6 @@
     "NS3_ENABLED_MODULES",
     "NS3_ENABLED_CONTRIBUTED_MODULES",
     "NS3_MODULE_PATH",
-    "ENABLE_REAL_TIME",
     "ENABLE_EXAMPLES",
     "ENABLE_TESTS",
     "EXAMPLE_DIRECTORIES",
@@ -78,7 +93,6 @@
     "VALGRIND_FOUND",
 ]
 
-ENABLE_REAL_TIME = False
 ENABLE_EXAMPLES = True
 ENABLE_TESTS = True
 NSCLICK = False
@@ -122,6 +136,7 @@
     "lte-pss-ff-mac-scheduler",
 ]
 
+
 #
 # Parse the examples-to-run file if it exists.
 #
@@ -134,97 +149,96 @@
     python_script_dir,
     example_tests,
     example_names_original,
-    python_tests):
-
+    python_tests,
+):
     # Look for the examples-to-run file exists.
-    if os.path.exists(examples_to_run_path):
+    if not os.path.exists(examples_to_run_path):
+        return
 
-        # Each tuple in the C++ list of examples to run contains
-        #
-        #     (example_name, do_run, do_valgrind_run)
-        #
-        # where example_name is the executable to be run, do_run is a
-        # condition under which to run the example, and do_valgrind_run is
-        # a condition under which to run the example under valgrind.  This
-        # is needed because NSC causes illegal instruction crashes with
-        # some tests when they are run under valgrind.
-        #
-        # Note that the two conditions are Python statements that
-        # can depend on ns3 configuration variables.  For example,
-        # when NSC was in the codebase, we could write:
-        #
-        #     ("tcp-nsc-lfn", "NSC_ENABLED == True", "NSC_ENABLED == False"),
-        #
-        cpp_examples = get_list_from_file(examples_to_run_path, "cpp_examples")
-        for example_name, do_run, do_valgrind_run in cpp_examples:
+    # Each tuple in the C++ list of examples to run contains
+    #
+    #     (example_name, do_run, do_valgrind_run)
+    #
+    # where example_name is the executable to be run, do_run is a
+    # condition under which to run the example, and do_valgrind_run is
+    # a condition under which to run the example under valgrind.  This
+    # is needed because NSC causes illegal instruction crashes with
+    # some tests when they are run under valgrind.
+    #
+    # Note that the two conditions are Python statements that
+    # can depend on ns3 configuration variables.  For example,
+    # when NSC was in the codebase, we could write:
+    #
+    #     ("tcp-nsc-lfn", "NSC_ENABLED == True", "NSC_ENABLED == False"),
+    #
+    cpp_examples = get_list_from_file(examples_to_run_path, "cpp_examples")
+    for example_name, do_run, do_valgrind_run in cpp_examples:
+        # Separate the example name from its arguments.
+        example_name_original = example_name
+        example_name_parts = example_name.split(" ", 1)
+        if len(example_name_parts) == 1:
+            example_name = example_name_parts[0]
+            example_arguments = ""
+        else:
+            example_name = example_name_parts[0]
+            example_arguments = example_name_parts[1]
 
-            # Separate the example name from its arguments.
-            example_name_original = example_name
-            example_name_parts = example_name.split(' ', 1)
-            if len(example_name_parts) == 1:
-                example_name      = example_name_parts[0]
-                example_arguments = ""
-            else:
-                example_name      = example_name_parts[0]
-                example_arguments = example_name_parts[1]
+        # Add the proper prefix and suffix to the example name to
+        # match what is done in the CMakeLists.txt file.
+        example_path = "%s%s-%s%s" % (APPNAME, VERSION, example_name, BUILD_PROFILE_SUFFIX)
 
-            # Add the proper prefix and suffix to the example name to
-            # match what is done in the CMakeLists.txt file.
-            example_path = "%s%s-%s%s" % (APPNAME, VERSION, example_name, BUILD_PROFILE_SUFFIX)
-
-            # Set the full path for the example.
-            example_path = os.path.join(cpp_executable_dir, example_path)
-            example_path += '.exe' if sys.platform == 'win32' else ''
-            example_name = os.path.join(
-                os.path.relpath(cpp_executable_dir, NS3_BUILDDIR),
-                example_name)
-            # Add all of the C++ examples that were built, i.e. found
-            # in the directory, to the list of C++ examples to run.
-            if os.path.exists(example_path):
-                # Add any arguments to the path.
-                if len(example_name_parts) != 1:
-                    example_path = "%s %s" % (example_path, example_arguments)
-                    example_name = "%s %s" % (example_name, example_arguments)
-
-                # Add this example.
-                example_tests.append((example_name, example_path, do_run, do_valgrind_run))
-                example_names_original.append(example_name_original)
+        # Set the full path for the example.
+        example_path = os.path.join(cpp_executable_dir, example_path)
+        example_path += ".exe" if sys.platform == "win32" else ""
+        example_name = os.path.join(os.path.relpath(cpp_executable_dir, NS3_BUILDDIR), example_name)
+        # Add all of the C++ examples that were built, i.e. found
+        # in the directory, to the list of C++ examples to run.
+        if os.path.exists(example_path):
+            # Add any arguments to the path.
+            if len(example_name_parts) != 1:
+                example_path = "%s %s" % (example_path, example_arguments)
+                example_name = "%s %s" % (example_name, example_arguments)
+
+            # Add this example.
+            example_tests.append((example_name, example_path, do_run, do_valgrind_run))
+            example_names_original.append(example_name_original)
+
+    # Each tuple in the Python list of examples to run contains
+    #
+    #     (example_name, do_run)
+    #
+    # where example_name is the Python script to be run and
+    # do_run is a condition under which to run the example.
+    #
+    # Note that the condition is a Python statement that can
+    # depend on ns3 configuration variables.  For example,
+    #
+    #     ("brite-generic-example", "ENABLE_BRITE == True", "False"),
+    #
+    python_examples = get_list_from_file(examples_to_run_path, "python_examples")
+    for example_name, do_run in python_examples:
+        # Separate the example name from its arguments.
+        example_name_parts = example_name.split(" ", 1)
+        if len(example_name_parts) == 1:
+            example_name = example_name_parts[0]
+            example_arguments = ""
+        else:
+            example_name = example_name_parts[0]
+            example_arguments = example_name_parts[1]
 
-        # Each tuple in the Python list of examples to run contains
-        #
-        #     (example_name, do_run)
-        #
-        # where example_name is the Python script to be run and
-        # do_run is a condition under which to run the example.
-        #
-        # Note that the condition is a Python statement that can
-        # depend on ns3 configuration variables.  For example,
-        #
-        #     ("realtime-udp-echo.py", "ENABLE_REAL_TIME == True"),
-        #
-        python_examples = get_list_from_file(examples_to_run_path, "python_examples")
-        for example_name, do_run in python_examples:
-            # Separate the example name from its arguments.
-            example_name_parts = example_name.split(' ', 1)
-            if len(example_name_parts) == 1:
-                example_name      = example_name_parts[0]
-                example_arguments = ""
-            else:
-                example_name      = example_name_parts[0]
-                example_arguments = example_name_parts[1]
+        # Set the full path for the example.
+        example_path = os.path.join(python_script_dir, example_name)
 
-            # Set the full path for the example.
-            example_path = os.path.join(python_script_dir, example_name)
+        # Add all of the Python examples that were found to the
+        # list of Python examples to run.
+        if os.path.exists(example_path):
+            # Add any arguments to the path.
+            if len(example_name_parts) != 1:
+                example_path = "%s %s" % (example_path, example_arguments)
 
-            # Add all of the Python examples that were found to the
-            # list of Python examples to run.
-            if os.path.exists(example_path):
-                # Add any arguments to the path.
-                if len(example_name_parts) != 1:
-                    example_path = "%s %s" % (example_path, example_arguments)
+            # Add this example.
+            python_tests.append((example_path, do_run))
 
-                # Add this example.
-                python_tests.append((example_path, do_run))
 
 #
 # The test suites are going to want to output status.  They are running
@@ -240,61 +254,65 @@
 #
 TMP_OUTPUT_DIR = "testpy-output"
 
+
 def read_test(test):
-    result = test.find('Result').text
-    name = test.find('Name').text
-    if not test.find('Reason') is None:
-        reason = test.find('Reason').text
+    result = test.find("Result").text
+    name = test.find("Name").text
+    if not test.find("Reason") is None:
+        reason = test.find("Reason").text
     else:
-        reason = ''
-    if not test.find('Time') is None:
-        time_real = test.find('Time').get('real')
+        reason = ""
+    if not test.find("Time") is None:
+        time_real = test.find("Time").get("real")
     else:
-        time_real = ''
+        time_real = ""
     return (result, name, reason, time_real)
 
+
 #
 # A simple example of writing a text file with a test result summary.  It is
 # expected that this output will be fine for developers looking for problems.
 #
-def node_to_text(test, f, test_type='Suite'):
+def node_to_text(test, f, test_type="Suite"):
     (result, name, reason, time_real) = read_test(test)
     if reason:
         reason = " (%s)" % reason
 
-    output = "%s: Test %s \"%s\" (%s)%s\n" % (result, test_type, name, time_real, reason)
+    output = '%s: Test %s "%s" (%s)%s\n' % (result, test_type, name, time_real, reason)
     f.write(output)
-    for details in test.findall('FailureDetails'):
+    for details in test.findall("FailureDetails"):
         f.write("    Details:\n")
-        f.write("      Message:   %s\n" % details.find('Message').text)
-        f.write("      Condition: %s\n" % details.find('Condition').text)
-        f.write("      Actual:    %s\n" % details.find('Actual').text)
-        f.write("      Limit:     %s\n" % details.find('Limit').text)
-        f.write("      File:      %s\n" % details.find('File').text)
-        f.write("      Line:      %s\n" % details.find('Line').text)
-    for child in test.findall('Test'):
-        node_to_text(child, f, 'Case')
+        f.write("      Message:   %s\n" % details.find("Message").text)
+        f.write("      Condition: %s\n" % details.find("Condition").text)
+        f.write("      Actual:    %s\n" % details.find("Actual").text)
+        f.write("      Limit:     %s\n" % details.find("Limit").text)
+        f.write("      File:      %s\n" % details.find("File").text)
+        f.write("      Line:      %s\n" % details.find("Line").text)
+    for child in test.findall("Test"):
+        node_to_text(child, f, "Case")
+
 
 def translate_to_text(results_file, text_file):
-    text_file += ('.txt' if '.txt' not in text_file else '')
-    print('Writing results to text file \"%s\"...' % text_file, end='')
+    text_file += ".txt" if ".txt" not in text_file else ""
+    print('Writing results to text file "%s"...' % text_file, end="")
     et = ET.parse(results_file)
 
-    with open(text_file, 'w', encoding='utf-8') as f:
-        for test in et.findall('Test'):
+    with open(text_file, "w", encoding="utf-8") as f:
+        for test in et.findall("Test"):
             node_to_text(test, f)
 
-        for example in et.findall('Example'):
-            result = example.find('Result').text
-            name = example.find('Name').text
-            if not example.find('Time') is None:
-                time_real = example.find('Time').get('real')
+        for example in et.findall("Example"):
+            result = example.find("Result").text
+            name = example.find("Name").text
+            if not example.find("Time") is None:
+                time_real = example.find("Time").get("real")
             else:
-                time_real = ''
-            output = "%s: Example \"%s\" (%s)\n" % (result, name, time_real)
+                time_real = ""
+            output = '%s: Example "%s" (%s)\n' % (result, name, time_real)
             f.write(output)
 
-    print('done.')
+    print("done.")
+
 
 #
 # A simple example of writing an HTML file with a test result summary.  It is
@@ -303,10 +321,10 @@
 # since it will probably grow over time.
 #
 def translate_to_html(results_file, html_file):
-    html_file += ('.html' if '.html' not in html_file else '')
-    print('Writing results to html file %s...' % html_file, end='')
+    html_file += ".html" if ".html" not in html_file else ""
+    print("Writing results to html file %s..." % html_file, end="")
 
-    with open(html_file, 'w', encoding='utf-8') as f:
+    with open(html_file, "w", encoding="utf-8") as f:
         f.write("<html>\n")
         f.write("<body>\n")
         f.write("<center><h1>ns-3 Test Results</h1></center>\n")
@@ -320,7 +338,7 @@
         # Iterate through the test suites
         #
         f.write("<h2>Test Suites</h2>\n")
-        for suite in et.findall('Test'):
+        for suite in et.findall("Test"):
             #
             # For each test suite, get its name, result and execution time info
             #
@@ -333,16 +351,19 @@
             # and print in red.
             #
             if result == "PASS":
-                f.write("<h3 style=\"color:green\">%s: %s (%s)</h3>\n" % (result, name, time))
+                f.write('<h3 style="color:green">%s: %s (%s)</h3>\n' % (result, name, time))
             elif result == "SKIP":
-                f.write("<h3 style=\"color:#ff6600\">%s: %s (%s) (%s)</h3>\n" % (result, name, time, reason))
+                f.write(
+                    '<h3 style="color:#ff6600">%s: %s (%s) (%s)</h3>\n'
+                    % (result, name, time, reason)
+                )
             else:
-                f.write("<h3 style=\"color:red\">%s: %s (%s)</h3>\n" % (result, name, time))
+                f.write('<h3 style="color:red">%s: %s (%s)</h3>\n' % (result, name, time))
 
             #
             # The test case information goes in a table.
             #
-            f.write("<table border=\"1\">\n")
+            f.write('<table border="1">\n')
 
             #
             # The first column of the table has the heading Result
@@ -364,9 +385,9 @@
             if result in ["CRASH", "SKIP", "VALGR"]:
                 f.write("<tr>\n")
                 if result == "SKIP":
-                    f.write("<td style=\"color:#ff6600\">%s</td>\n" % result)
+                    f.write('<td style="color:#ff6600">%s</td>\n' % result)
                 else:
-                    f.write("<td style=\"color:red\">%s</td>\n" % result)
+                    f.write('<td style="color:red">%s</td>\n' % result)
                 f.write("</tr>\n")
                 f.write("</table>\n")
                 continue
@@ -396,8 +417,7 @@
             #
             # Now iterate through all the test cases.
             #
-            for case in suite.findall('Test'):
-
+            for case in suite.findall("Test"):
                 #
                 # Get the name, result and timing information from xml to use in
                 # printing table below.
@@ -427,8 +447,7 @@
                     #
 
                     first_row = True
-                    for details in case.findall('FailureDetails'):
-
+                    for details in case.findall("FailureDetails"):
                         #
                         # Start a new row in the table for each possible Failure Detail
                         #
@@ -436,7 +455,7 @@
 
                         if first_row:
                             first_row = False
-                            f.write("<td style=\"color:red\">%s</td>\n" % result)
+                            f.write('<td style="color:red">%s</td>\n' % result)
                             f.write("<td>%s</td>\n" % name)
                             f.write("<td>%s</td>\n" % time)
                         else:
@@ -445,12 +464,12 @@
                             f.write("<td></td>\n")
 
                         f.write("<td>")
-                        f.write("<b>Message: </b>%s, " % details.find('Message').text)
-                        f.write("<b>Condition: </b>%s, " % details.find('Condition').text)
-                        f.write("<b>Actual: </b>%s, " % details.find('Actual').text)
-                        f.write("<b>Limit: </b>%s, " % details.find('Limit').text)
-                        f.write("<b>File: </b>%s, " % details.find('File').text)
-                        f.write("<b>Line: </b>%s" % details.find('Line').text)
+                        f.write("<b>Message: </b>%s, " % details.find("Message").text)
+                        f.write("<b>Condition: </b>%s, " % details.find("Condition").text)
+                        f.write("<b>Actual: </b>%s, " % details.find("Actual").text)
+                        f.write("<b>Limit: </b>%s, " % details.find("Limit").text)
+                        f.write("<b>File: </b>%s, " % details.find("File").text)
+                        f.write("<b>Line: </b>%s" % details.find("Line").text)
                         f.write("</td>\n")
 
                         #
@@ -471,7 +490,7 @@
                     #   +--------+----------------+------+---------+
                     #
                     f.write("<tr>\n")
-                    f.write("<td style=\"color:green\">%s</td>\n" % result)
+                    f.write('<td style="color:green">%s</td>\n' % result)
                     f.write("<td>%s</td>\n" % name)
                     f.write("<td>%s</td>\n" % time)
                     f.write("<td>%s</td>\n" % reason)
@@ -490,7 +509,7 @@
         #
         # Example status is rendered in a table just like the suites.
         #
-        f.write("<table border=\"1\">\n")
+        f.write('<table border="1">\n')
 
         #
         # The table headings look like,
@@ -508,7 +527,6 @@
         # Now iterate through all the examples
         #
         for example in et.findall("Example"):
-
             #
             # Start a new row for each example
             #
@@ -524,11 +542,11 @@
             # in red; otherwise green.  This goes in a <td> ... </td> table data
             #
             if result == "PASS":
-                f.write("<td style=\"color:green\">%s</td>\n" % result)
+                f.write('<td style="color:green">%s</td>\n' % result)
             elif result == "SKIP":
-                f.write("<td style=\"color:#ff6600\">%s</fd>\n" % result)
+                f.write('<td style="color:#ff6600">%s</fd>\n' % result)
             else:
-                f.write("<td style=\"color:red\">%s</td>\n" % result)
+                f.write('<td style="color:red">%s</td>\n' % result)
 
             #
             # Write the example name as a new tag data.
@@ -561,7 +579,8 @@
         f.write("</body>\n")
         f.write("</html>\n")
 
-    print('done.')
+    print("done.")
+
 
 #
 # Python Control-C handling is broken in the presence of multiple threads.
@@ -571,6 +590,7 @@
 #
 thread_exit = False
 
+
 def sigint_hook(signal, frame):
     global thread_exit
     thread_exit = True
@@ -601,14 +621,17 @@
         with open(lock_filename, "rt", encoding="utf-8") as f:
             for line in f:
                 if line.startswith("top_dir ="):
-                    key, val = line.split('=')
+                    key, val = line.split("=")
                     top_dir = eval(val.strip())
                 if line.startswith("out_dir ="):
-                    key, val = line.split('=')
+                    key, val = line.split("=")
                     out_dir = eval(val.strip())
 
     except FileNotFoundError:
-        print('The .lock-ns3 file was not found.  You must configure before running test.py.', file=sys.stderr)
+        print(
+            "The .lock-ns3 file was not found.  You must configure before running test.py.",
+            file=sys.stderr,
+        )
         sys.exit(2)
 
     global NS3_BASEDIR
@@ -616,7 +639,7 @@
     global NS3_BUILDDIR
     NS3_BUILDDIR = out_dir
 
-    with open(lock_filename, encoding='utf-8') as f:
+    with open(lock_filename, encoding="utf-8") as f:
         for line in f.readlines():
             for item in interesting_config_items:
                 if line.startswith(item):
@@ -626,6 +649,7 @@
         for item in interesting_config_items:
             print("%s ==" % item, eval(item))
 
+
 #
 # It seems pointless to fork a process to run ns3 to fork a process to run
 # the test runner, so we just run the test runner directly.  The main thing
@@ -661,7 +685,7 @@
         os.environ["PYTHONPATH"] += ":" + pypath
 
     if args.verbose:
-        print("os.environ[\"PYTHONPATH\"] == %s" % os.environ["PYTHONPATH"])
+        print('os.environ["PYTHONPATH"] == %s' % os.environ["PYTHONPATH"])
 
     if sys.platform == "darwin":
         if not have_DYLD_LIBRARY_PATH:
@@ -669,28 +693,29 @@
         for path in NS3_MODULE_PATH:
             os.environ["DYLD_LIBRARY_PATH"] += ":" + path
         if args.verbose:
-            print("os.environ[\"DYLD_LIBRARY_PATH\"] == %s" % os.environ["DYLD_LIBRARY_PATH"])
+            print('os.environ["DYLD_LIBRARY_PATH"] == %s' % os.environ["DYLD_LIBRARY_PATH"])
     elif sys.platform == "win32":
         if not have_PATH:
             os.environ["PATH"] = ""
         for path in NS3_MODULE_PATH:
-            os.environ["PATH"] += ';' + path
+            os.environ["PATH"] += ";" + path
         if args.verbose:
-            print("os.environ[\"PATH\"] == %s" % os.environ["PATH"])
+            print('os.environ["PATH"] == %s' % os.environ["PATH"])
     elif sys.platform == "cygwin":
         if not have_PATH:
             os.environ["PATH"] = ""
         for path in NS3_MODULE_PATH:
             os.environ["PATH"] += ":" + path
         if args.verbose:
-            print("os.environ[\"PATH\"] == %s" % os.environ["PATH"])
+            print('os.environ["PATH"] == %s' % os.environ["PATH"])
     else:
         if not have_LD_LIBRARY_PATH:
             os.environ["LD_LIBRARY_PATH"] = ""
         for path in NS3_MODULE_PATH:
             os.environ["LD_LIBRARY_PATH"] += ":" + str(path)
         if args.verbose:
-            print("os.environ[\"LD_LIBRARY_PATH\"] == %s" % os.environ["LD_LIBRARY_PATH"])
+            print('os.environ["LD_LIBRARY_PATH"] == %s' % os.environ["LD_LIBRARY_PATH"])
+
 
 #
 # Short note on generating suppressions:
@@ -778,8 +803,8 @@
 # VALGRIND_SUPPRESSIONS_FILE = "testpy.supp"
 VALGRIND_SUPPRESSIONS_FILE = None
 
-def run_job_synchronously(shell_command, directory, valgrind, is_python, build_path=""):
 
+def run_job_synchronously(shell_command, directory, valgrind, is_python, build_path=""):
     if VALGRIND_SUPPRESSIONS_FILE is not None:
         suppressions_path = os.path.join(NS3_BASEDIR, VALGRIND_SUPPRESSIONS_FILE)
 
@@ -793,10 +818,15 @@
 
     if valgrind:
         if VALGRIND_SUPPRESSIONS_FILE:
-            cmd = "valgrind --suppressions=%s --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s" % (suppressions_path,
-                path_cmd)
+            cmd = (
+                "valgrind --suppressions=%s --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s"
+                % (suppressions_path, path_cmd)
+            )
         else:
-            cmd = "valgrind --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s" % (path_cmd)
+            cmd = (
+                "valgrind --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s"
+                % (path_cmd)
+            )
     else:
         cmd = path_cmd
 
@@ -804,7 +834,9 @@
         print("Synchronously execute %s" % cmd)
 
     start_time = time.time()
-    proc = subprocess.Popen(cmd, shell=True, cwd=directory, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+    proc = subprocess.Popen(
+        cmd, shell=True, cwd=directory, stdout=subprocess.PIPE, stderr=subprocess.PIPE
+    )
     stdout_results, stderr_results = proc.communicate()
     elapsed_time = time.time() - start_time
 
@@ -814,6 +846,7 @@
         try:
             stream_results = stream_results.decode()
         except UnicodeDecodeError:
+
             def decode(byte_array: bytes):
                 try:
                     byte_array.decode()
@@ -823,7 +856,9 @@
             # Find lines where the decoding error happened
             non_utf8_lines = list(map(lambda line: decode(line), stream_results.splitlines()))
             non_utf8_lines = list(filter(lambda line: line is not None, non_utf8_lines))
-            print(f"Non-decodable characters found in {stream_name} output of {cmd}: {non_utf8_lines}")
+            print(
+                f"Non-decodable characters found in {stream_name} output of {cmd}: {non_utf8_lines}"
+            )
 
             # Continue decoding on errors
             stream_results = stream_results.decode(errors="backslashreplace")
@@ -838,6 +873,7 @@
 
     return (retval, stdout_results, stderr_results, elapsed_time)
 
+
 #
 # This class defines a unit of testing work.  It will typically refer to
 # a test suite to run using the test-runner, or an example to run directly.
@@ -973,6 +1009,7 @@
     def set_elapsed_time(self, elapsed_time):
         self.elapsed_time = elapsed_time
 
+
 #
 # The worker thread class that handles the actual running of a given test.
 # Once spawned, it receives requests for work through its input_queue and
@@ -1026,8 +1063,14 @@
                     # know.  It will be something like "examples/udp/udp-echo" or
                     # "examples/wireless/mixed-wireless.py"
                     #
-                    (job.returncode, job.standard_out, job.standard_err, et) = run_job_synchronously(job.shell_command,
-                        job.cwd, args.valgrind, job.is_pyexample, job.build_path)
+                    (
+                        job.returncode,
+                        job.standard_out,
+                        job.standard_err,
+                        et,
+                    ) = run_job_synchronously(
+                        job.shell_command, job.cwd, args.valgrind, job.is_pyexample, job.build_path
+                    )
                 else:
                     #
                     # If we're a test suite, we need to provide a little more info
@@ -1035,12 +1078,22 @@
                     # file name
                     #
                     if args.update_data:
-                        update_data = '--update-data'
+                        update_data = "--update-data"
                     else:
-                        update_data = ''
-                    (job.returncode, job.standard_out, job.standard_err, et) = run_job_synchronously(job.shell_command +
-                        " --xml --tempdir=%s --out=%s %s" % (job.tempdir, job.tmp_file_name, update_data),
-                        job.cwd, args.valgrind, False)
+                        update_data = ""
+                    (
+                        job.returncode,
+                        job.standard_out,
+                        job.standard_err,
+                        et,
+                    ) = run_job_synchronously(
+                        job.shell_command
+                        + " --xml --tempdir=%s --out=%s %s"
+                        % (job.tempdir, job.tmp_file_name, update_data),
+                        job.cwd,
+                        args.valgrind,
+                        False,
+                    )
 
                 job.set_elapsed_time(et)
 
@@ -1054,17 +1107,21 @@
 
                 self.output_queue.put(job)
 
+
 #
 # This function loads the list of previously successful or skipped examples and test suites.
 #
 def load_previously_successful_tests():
     import glob
+
     previously_run_tests_to_skip = {"test": [], "example": []}
     previous_results = glob.glob(f"{TMP_OUTPUT_DIR}/*-results.xml")
     if not previous_results:
         print("No previous runs to rerun")
         exit(-1)
-    latest_result_file = list(sorted(previous_results, key=lambda x: os.path.basename(x), reverse=True))[0]
+    latest_result_file = list(
+        sorted(previous_results, key=lambda x: os.path.basename(x), reverse=True)
+    )[0]
 
     try:
         previous_run_results = ET.parse(latest_result_file)
@@ -1074,15 +1131,18 @@
 
     for test_type in ["Test", "Example"]:
         if previous_run_results.find(test_type):
-            temp = list(map(lambda x: (x.find('Name').text, x.find('Result').text),
-                            previous_run_results.findall(test_type)
-                            )
-                        )
-            temp = list(filter(lambda x: x[1] in ['PASS', 'SKIP'], temp))
+            temp = list(
+                map(
+                    lambda x: (x.find("Name").text, x.find("Result").text),
+                    previous_run_results.findall(test_type),
+                )
+            )
+            temp = list(filter(lambda x: x[1] in ["PASS", "SKIP"], temp))
             temp = [x[0] for x in temp]
             previously_run_tests_to_skip[test_type.lower()] = temp
     return previously_run_tests_to_skip
 
+
 #
 # This is the main function that does the work of interacting with the
 # test-runner itself.
@@ -1100,7 +1160,7 @@
     # Set the proper suffix.
     #
     global BUILD_PROFILE_SUFFIX
-    if BUILD_PROFILE == 'release':
+    if BUILD_PROFILE == "release":
         BUILD_PROFILE_SUFFIX = ""
     else:
         BUILD_PROFILE_SUFFIX = "-" + BUILD_PROFILE
